//  **************** ETREE my own XTREE *******************
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <alloc.h>
#include <time.h>
#include <dir.h>
#include <sub.h>

#include "etree.h"

int far Handler24(word err, word ax );  // Handle int 0x24 critical error

char StartupPath[60];
int TestForVirus = 1;

char DateString[20];    // current date
struct time T;          // current time
struct date D;          // current date

void PutDate(char *S,byte pos,byte height)
{
word wx=WindowX,wy=WindowY,wh=WindowH,ww=WindowW,x=vWhereX(),y=vWhereY();
byte color=_Attrib;
word cx;
    cx=GetCursorX();
    vWindow(0,0,ScrnW,ScrnH);
    pos = pos==0xff ? (ScrnW-strlen(S))/2 : ScrnW-pos;
    vGoto(pos,height);
    vColor(Sub.firstFG ,BLACK);
    vPuts(S);
    _Attrib=color;
    vWindow(wx,wy,ww,wh);
    vGoto(x,y);
    SetCursorXY(cx,y);
}

void ShowTime(void)
{
    sprintf(str,"%02.2d:%02.2d:%02.2d",T.ti_hour,T.ti_min,T.ti_sec);
    PutDate(str,8,0);
}

void pascal far TestTime(byte s)
{
static long SecCnt=time(0);
    s=s;
    if(time(0)>SecCnt) {
        gettime(&T);
        ShowTime();
        time(&SecCnt);
//        if(TimeOut++>TIME_OUT) {      }
    }
}


char InstDat[]=
{   'S','u','B','_','C','o','p','y','w','r','i','t','e',' ','E','.','S','.',
    'F','.',' ','d','e',' ','S','m','i','d','t','.',0,0,0,0,0, // ID 35 bytes

    ' ','U','p',' ','D','o','w','n',' ','E','n','t','e','r',' ',' ','A','l',
    't',' ','X','-','Q','u','i','t',' ',0,0,0,  // BottomLine 60 bytes
    0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, // Bottom

                // start of Sub.xx defaults
    'M','E','N','U','.','D','A','T',0,0,          // graph drv 40 bytes
    0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,
    WHITE,RED,          // Caps  FG & BG
    LIGHTCYAN,BLACK,    // first FG & BG
    0,                  // statusline
    0,0,                // screen x,y correction
    7,                  // maxzoom
    0x03,               // sendtype
    0xe7,               // sendconfig   output to file and comport config
    ON,                 // sendLF
    10,                 // windowcnt            start van sub defaults
    15,                 // mousespeed
    10,                 // mousefact
    0xff,               // switches       save screen = 0x02
    0,0,                // prog type & version
    0x01,               // alarm
    0x01,               // alarmcnt
    0x00,               // vidmode
    ' ',                // fillchar for CStr()
    0,                  // Installed
    0,                  // sendprot
    10,10,              // acceleration & accelcnt
    0,0,0,0,0,0,0,      // sub extra
    0,0,0,0,            // long for file offset of default struct
    0,                  // progsize
//              For each window (windowcnt)
// BORDER   TITLE      TEXT     SELECT    X    Y    W    H
// FG  BG   FG   BG   FG   BG  FG   BG  255=center
//   15,   0,   15,   0,  15,   0,   0,   7, 255, 255,  42,  15,    // WNDTEXT
   3,   0,   0,   3,  14,   0,   0,   2, 255, 255,  42,  15,    // WNDTEXT
   0,   3,  15,   3,   0,   3,  15,   0, 255, 255,  62,  10,    // WNDDIR
  15,   1,  15,   1,  15,   1,  15,   1, 255, 255,  50,   3,    // WNDEDIT
  15,   4,  15,   4,  15,   4,  15,   0, 255, 255,  40,   4,    // WNDERR
  15,   5,   0,   5,  15,   5,   0,   7, 255, 255,  42,   5,    // WNDWAR
  15,   2,  15,   2,  15,   2,  15,   0, 255, 255,  20,   4,    // WNDMES
   0,   3,  15,   3,   0,   3,  15,   0, 255, 255,  40,  18,    // WNDHLP
  15,   0,  15,   0,  15,   0,  15,   1, 255,   0,  42,  10,    // hmenu
//  15,   0,  15,   0,  15,   0,  15,   1, 255,   0,  42,  10,    // input
  15,   0,  15,   0,  15,   0,  15,   1, 255, 255,  50,  20,    // input
  15,   1,  15,   1,  15,   1,  15,   0, 255, 255,  80,  25,    // USER
};


int Etree( Directory *Root )
{
word start,sel,num,hight;
  crtinit("");
  start=sel=1;
  num=Root->filecnt+Root->dircnt;
  for( ; ; )
  {
    vGoto(0,0);
    for(TREEDIR *d=Root->Dirs; d ; d=d->nextdir)
      vPutf("%13.13s\\  %5u\n",d->name,d->size);

    vPuth(WindowW,'');

    for(TREEFILE *f=Root->Files; f ; f=f->nextfile)
      vPutf("%13.13s  %5u\n",f->name,f->size);

    if( !CursorKey(GetMouseKey(),&start,&sel,num,hight) )
      switch(LastKey)
      {
        case 0x0d: /* ENTER:*/   break;
        case ESC: case 'q': case aXKEY: return Success;
      }
  }
  return 0;
}


void PrintDosHelp(void)
{
    vPuts("ETREE [option(s)] [path]\n");
    vPuts("ETREE filemanager made by E.S.F. de Smidt HAARLEM HOLLAND\n");
    vPuts(" -u   do not keep user screen\n");
    vPuts(" -v   do not test program integrity\n");
    vPuts(" -?   print this message\n");
}

int GetOptions(int argc,char **argv)
{
int optcnt=0;
//char Str[60];
  if( argc == 1 )
    return 0;
  for( int t=1; t<argc ; t++)
  {
    char *s=argv[t];        // get a pointer to option
    if( *s != '-' && *s != '/' )    // is it not an option ?
      break;
    optcnt++;               // count argv's that are options
    s++;                    // skip option marker
    while( *s )             // scan string
    {
      switch( *s )
      {
        case '-': case '/': break;                          // skip marker
        case 'u': case 'U': Sub.switches ^= 0x02; break;    // keep user screen
        case 'v': case 'V': TestForVirus = 0; break;    // don't test integrity
        case '?': PrintDosHelp(); exit(-1);
        default :
/*
          strcpy(Str,s+1);      // get chars after option char
          if(*Str)
          {
            char *ts = Str;
            while ( *ts && *ts!='-' && *ts!='/' )
              ts++;
            *ts = 0;
          }
          switch( *s )
          {
//            case 'p':   strcpy(FliUsePalette, Str); break;
//            case 'd':   FliSaveDelay        = atoi(Str); break;
            default:    return Error;                       // unknown option
          }
          s+=strlen(Str);           // skip over this string
*/
          break;
      }
      s++;
    }
  }
  return optcnt;                    // return number of argv's used by options
}

int AddFile( Directory *d, ffblk *ffblk )
{
TREEFILE *f;
  if( (f = new TREEFILE) == 0)
    return Error;
  f->nextfile=0;
  f->name=(char *)new char[strlen(ffblk->ff_name)+1];
  strncpy(f->name,ffblk->ff_name,13);
  f->attrib=ffblk->ff_attrib;
  f->time  =ffblk->ff_ftime;
  f->date  =ffblk->ff_fdate;
  f->size  =ffblk->ff_fsize;
  if( d->filecnt == 0 )
  {
    d->Files=d->LastFile=f;
  } else {
    d->LastFile->nextfile=f;
    d->LastFile=f;
  }
  d->filecnt++;
  return Success;
}

int AddDir( Directory *d, ffblk *ffblk )
{
TREEDIR *f;
  if( (f = new TREEDIR) == 0)
    return Error;
  f->nextdir=0;
  f->name=(char *)new char[strlen(ffblk->ff_name)+1];
  strncpy(f->name,ffblk->ff_name,13);
  f->attrib=ffblk->ff_attrib;
  f->time  =ffblk->ff_ftime;
  f->date  =ffblk->ff_fdate;
  f->size  =ffblk->ff_fsize;
  if( d->dircnt == 0 )
  {
    d->Dirs=d->LastDir=f;
  } else {
    d->LastDir->nextdir=f;
    d->LastDir=f;
  }
  d->dircnt++;
  return Success;
}


int FillRoot( Directory *r )
{
int done;
struct ffblk ffblk;
char Path[]="\\*.*";

    for(done=findfirst(Path,&ffblk,0); !done ; done=findnext(&ffblk) )
      if( AddFile(r,&ffblk) == Error )
      {
        puterror(ERR,"No more memory!");
        break;
      }

    for(done=findfirst(Path,&ffblk,0x10); !done ; done=findnext(&ffblk))
      if( ffblk.ff_attrib&0x10 && !(ffblk.ff_name[0]=='.' &&
              ffblk.ff_name[1]==0))
        if( AddDir(r,&ffblk) == Error )
        {
          puterror(ERR,"No more memory!");
          break;
        }

/*
    if( SUBDIRSORT && ((maxnum-totcnt)*6) > totcnt) {   // space for sorting ?
        Sort(DirData,filecnt,13);                       // sort files
        Sort(DirData+(filecnt*13),totcnt-filecnt,13);   // and directories
    }
*/
  return Success;
}

int main(int argc,char **argv)
{
  strcpy(ProgramExe,argv[0]);
  SetSub(InstDat+95);
  InitMouse();

  harderr((int(far*)(int,int,int,int))Handler24);  // init int 24 fatal error handler

  if( GetOptions(argc,argv) == -1)
  {
    printf("Invalid option\n");
    return Error;
  }

/*
  if(ac>=argc) LoadAll=0;
  strcpy(str,ac>=argc?"MENU":*(argv+argc-1));
  strupr(str);
  add(str,"DAT");
  strcpy(StartFile,str);
  if(LoadAll)
      strcpy(str,"MENU");
  add(str,"DAT");
  strupr(str);
  strcpy(MainMenu.FileName,str);
*/
/*
  if(TestForVirus)
  {
    if( CheckCrc(argv[0],CrcOffset,CrcValue) != 0)
    {
      puterror(ERR,"\nProgram possibly infected with a virus!\n\
Check your system for a VIRUS NOW!\n");
    } else
      vPuts("Program integrity OK!\n");
    Fail = FALSE;                           // continue after virus error
  }
*/
  crtsave();
  Sub_CheckLock=TestTime;


// Get currentdrive
// Get currentdirectory

Directory Root;
// make list off ROOT & path to current directory
  ClearStruct(&Root);
  FillRoot( &Root );

  Etree( &Root );

// restore drive and directory

  crtrestore();
  exit(Fail);
  return Fail;        // dummy
}


